/*  removeStorage: removes a key from localStorage and its sibling expiracy key
    params:
        key <string>     : localStorage key to remove
    returns:
        <boolean> : telling if operation succeeded
 */
 function removeStorage(name) {
    try {
        localStorage.removeItem(name);
        localStorage.removeItem(name + '_expiresIn');
    } catch(e) {
        console.log('removeStorage: Error removing key ['+ key + '] from localStorage: ' + JSON.stringify(e) );
        return false;
    }
    return true;
}
/*  getStorage: retrieves a key from localStorage previously set with setStorage().
    params:
        key <string> : localStorage key
    returns:
        <string> : value of localStorage key
        null : in case of expired key or failure
 */
function getStorage(key)
 {

    var now = Date.now();  //epoch time, lets deal only with integer
    // set expiration for storage
    var expiresIn = localStorage.getItem(key+'_expiresIn');
    if (expiresIn===undefined || expiresIn===null) { expiresIn = 0; }

    if (expiresIn < now) {// Expired
        removeStorage(key)
;
        return null;
    } else {
        try {
            var value = localStorage.getItem(key)
;
            return value;
        } catch(e) {
            console.log('getStorage: Error reading key ['+ key + '] from localStorage: ' + JSON.stringify(e) );
            return null;
        }
    }
}
/*  setStorage: writes a key into localStorage setting a expire time
    params:
        key <string>     : localStorage key
        value <string>   : localStorage value
        expires <number> : number of seconds from now to expire the key
    returns:
        <boolean> : telling if operation succeeded
 */
function setStorage(key, value, expires) {

    if (expires===undefined || expires===null) {
        expires = (24*60*60);  // default: seconds for 1 day
    } else {
        expires = Math.abs(expires); //make sure it's positive
    }

    var now = Date.now();  //millisecs since epoch time, lets deal only with integer
    var schedule = now + expires*1000; 
    try {
        localStorage.setItem(key, value);
        localStorage.setItem(key + '_expiresIn', schedule);
    } catch(e) {
        console.log('setStorage: Error setting key ['+ key + '] in localStorage: ' + JSON.stringify(e) );
        return false;
    }
    return true;
}
















document.addEventListener("DOMContentLoaded", function () {
  const video = document.getElementById("banner-video");
  const firstBanner = document.getElementById("first-banner");
  const secondBanner = document.getElementById("second-banner");

  video.addEventListener("ended", function () {
      firstBanner.style.display = "none";
      secondBanner.style.display = "block";
  });
});




// SLIDER

        window.addEventListener('load', function() {
            const savedReward = getStorage('reward_value'); // Check for saved reward in localStorage
            const spinnerLink = document.querySelector('.spinner-link');
            const spinnerTextPop = document.querySelector('.spiner-text-popup a');
            console.log(spinnerTextPop);
            console.log(savedReward)
        
            if (savedReward) {
                spinnerTextPop.innerHTML = savedReward;
                document.querySelector('.spiner-text-popup').style.display = "block"
                
            } else {
                console.log('else')
                setTimeout(function() {
                    document.querySelector('.spinner-link').classList.add('show');
                }, 500); 
            }
            
        });

  // const testimonials = document.querySelectorAll('.testimonial');
  // const dots = document.querySelectorAll('.dot');
  // let currentIndex = 0;
  // let autoPlayInterval;

  // function showTestimonial(index) {
  //   // Hide all testimonials
  //   testimonials.forEach((testimonial, i) => {
  //     if (i === index) {
  //       gsap.fromTo(
  //         testimonial,
  //         { opacity: 0, x: 100 },
  //         { opacity: 1, x: 0, duration: 1, display: "block" }
  //       );
  //       testimonial.classList.add('active');
  //     } else {
  //       gsap.to(testimonial, { opacity: 0, x: -100, duration: 1, display: "none" });
  //       testimonial.classList.remove('active');
  //     }
  //   });

  //   // Update active dot
  //   dots.forEach(dot => dot.classList.remove('active'));
  //   dots[index].classList.add('active');
  // }

  // function nextSlide() {
  //   currentIndex = (currentIndex + 1) % testimonials.length;
  //   showTestimonial(currentIndex);
  // }

  // function setAutoPlay() {
  //   autoPlayInterval = setInterval(nextSlide, 3000); // Change every 3 seconds
  // }

  // // Dot click functionality
  // dots.forEach(dot => {
  //   dot.addEventListener('click', (e) => {
  //     clearInterval(autoPlayInterval); // Stop autoplay
  //     currentIndex = parseInt(e.target.getAttribute('data-slide'));
  //     showTestimonial(currentIndex);
  //     setAutoPlay(); // Restart autoplay
  //   });
  // });

  // // Start autoplay
  // setAutoPlay();


  document.addEventListener('DOMContentLoaded', function() {
    const words = ["Vision", "Dreams", "Impact "];
    let i = 0;
    let j = 0;
    let currentWord = '';
    let isDeleting = false;
    const typingSpeed = 300; // Adjusted typing speed
    const deletingSpeed = 300; // Speed for deleting characters
    const pause = 800; // Adjusted pause duration
    const textElement = document.getElementById('animated-text');
  
    function type() {
      if (isDeleting) {
        currentWord = words[i].substring(0, j--);
      } else {
        currentWord = words[i].substring(0, j++);
      }
  
      textElement.textContent = currentWord;
  
      if (!isDeleting && j === words[i].length) {
        setTimeout(() => {
          isDeleting = true;
          type();
        }, pause);
      } else if (isDeleting && j === 0) {
        isDeleting = false;
        i = (i + 1) % words.length;
        type();
      } else {
        const speed = isDeleting ? deletingSpeed : typingSpeed;
        setTimeout(type, speed);
      }
    }
  
    setTimeout(type, 100); // Start typing after 7 seconds
});

  // document.querySelectorAll('.expertise-item').forEach(item => {
  //   item.addEventListener('mouseenter', (e) => {
  //     const back = item.querySelector('.back');
  //     const rect = item.getBoundingClientRect();
  //     const x = e.clientX - rect.left;
  //     const y = e.clientY - rect.top;
  //     const direction = getDirection(x, y, rect.width, rect.height);
  
  //     gsap.set(back, { top: direction.top, left: direction.left });
  //     gsap.to(back, { top: 0, left: 0, duration: 0.7, ease: "power2.inOut" });
  //   });
  
  //   item.addEventListener('mouseleave', (e) => {
  //     const back = item.querySelector('.back');
  //     const rect = item.getBoundingClientRect();
  //     const x = e.clientX - rect.left;
  //     const y = e.clientY - rect.top;
  //     const direction = getDirection(x, y, rect.width, rect.height);
  
  //     gsap.to(back, { top: direction.top, left: direction.left, duration: 0.4});
  //   });
  // });
  
  // function getDirection(x, y, width, height) {
  //   const top = { top: '-110%', left: '0' };
  //   const bottom = { top: '110%', left: '0' };
  //   const left = { top: '0', left: '-110%' };
  //   const right = { top: '0', left: '110%' };
  
  //   const fromTop = y < height / 2 && x > y && x < width - y;
  //   const fromBottom = y > height / 2 && x > height - y && x < width - (height - y);
  //   const fromLeft = x < width / 2 && y > x && y < height - x;
  //   const fromRight = x > width / 2 && y > width - x && y < height - (width - x);
  
  //   if (fromTop) return top;
  //   if (fromBottom) return bottom;
  //   if (fromLeft) return left;
  //   if (fromRight) return right;
  // }

  const nodes = [].slice.call(document.querySelectorAll('.expertise-item'), 0);
  const directions  = { 0: 'top', 1: 'right', 2: 'bottom', 3: 'left' };
  const classNames = ['in', 'out'].map((p) => Object.values(directions).map((d) => `${p}-${d}`)).reduce((a, b) => a.concat(b));
  
  const getDirectionKey = (ev, node) => {
    const { width, height, top, left } = node.getBoundingClientRect();
    const l = ev.pageX - (left + window.pageXOffset);
    const t = ev.pageY - (top + window.pageYOffset);
    const x = (l - (width/2) * (width > height ? (height/width) : 1));
    const y = (t - (height/2) * (height > width ? (width/height) : 1));
    return Math.round(Math.atan2(y, x) / 1.57079633 + 5) % 4;
  }
  
  class Item {
    constructor(element) {
      this.element = element;    
      this.element.addEventListener('mouseover', (ev) => this.update(ev, 'in'));
      this.element.addEventListener('mouseout', (ev) => this.update(ev, 'out'));
    }
    
    update(ev, prefix) {
      this.element.classList.remove(...classNames);
      this.element.classList.add(`${prefix}-${directions[getDirectionKey(ev, this.element)]}`);
    }
  }
  
  nodes.forEach(node => new Item(node));

  window.addEventListener('load', function() {
    setTimeout(function() {
        document.querySelectorAll('.img-list li').forEach(function(li) {
            li.classList.add('show');
        });
    }, 1000);
});